#!/usr/bin/perl

# load_dor_params.pl
# John Jacobsen, NPX Designs, Inc., jacobsen\@npxdesigns.com
# Started: Tue Sep 13 14:41:08 2005

package MY_PACKAGE;
use strict;

my $f = shift; die "$f not found!\n" unless -f $f;

sub load {
    my $name = shift; die unless defined $name;
    my $val  = shift; die unless defined $val;
    open(PF, ">$name") || die "Can't open $name for writing: $!\n";
    print PF "$val\n";
    close PF;
}

foreach my $card (</proc/driver/domhub/card?>) {
    open(F, $f) || die "Can't open $f: $!\n";
    while(<F>) {
	if (! /^\s*\#/) {
	    load("$card/autodac",$1) if /autodac\s*=\s*(\d+)/;
	    load("$card/dacmax",$1)  if /dacmax\s*=\s*(\d+)/;
	    load("$card/minclev",$1) if /minclev\s*=\s*(\d+)/;
	    load("$card/maxclev",$1) if /maxclev\s*=\s*(\d+)/;
	    load("$card/rdelay",$1)  if /rdelay\s*=\s*(\d+)/;
	    load("$card/sdelay",$1)  if /sdelay\s*=\s*(\d+)/;
	    load("$card/thresh",$1)  if /thresh\s*=\s*(\d+)/;
	}
    }
    close F;
}

__END__

