/* Thanks to Arthur for this one, modded by JJ to have any number of queues */
#ifndef __ACKQ_H__
#define __ACKQ_H__
#define NACKQBITS    10
#define NACKQENTRIES (1<<NACKQBITS)
#define ACKQMASK    (NACKQENTRIES-1)

typedef unsigned short aqType;

typedef struct aqTypeStruct {
  aqType aq[NACKQENTRIES];
  unsigned aqHead, aqTail;
} ackQueue;

static inline void emptyAckQ(ackQueue *q) { q->aqHead = q->aqTail = 0; }
static inline int getAckQHead(ackQueue *q) { return q->aqHead&ACKQMASK; }
static inline int getAckQTail(ackQueue *q) { return q->aqTail&ACKQMASK; }
static inline void putAckQ(ackQueue *q, aqType v) { q->aq[getAckQHead(q)]=v; q->aqHead++; }
static inline aqType getAckQ(ackQueue *q) {
  const aqType ret = q->aq[getAckQTail(q)];
  q->aqTail++;
  return ret;
}
static inline int nAckQEntries(ackQueue *q) { return q->aqHead - q->aqTail; }
static inline int ackQisFull(ackQueue *q) { return NACKQENTRIES == nAckQEntries(q); }
static inline int ackQisEmpty(ackQueue *q) { return q->aqHead == q->aqTail; }

/* Old 
static unsigned short aq[NACKQENTRIES];
static unsigned aqHead, aqTail;
static inline int getAckQHead(void) { return aqHead&ACKQMASK; }
static inline int getAckQTail(void) { return aqTail&ACKQMASK; }
static inline void putAckQ(unsigned short v) { aq[getAckQHead()]=v; aqHead++; }
static inline unsigned short getAckQ(void) {
  const unsigned short ret = aq[getAckQTail()];
  aqTail++;
  return ret;
}
static inline int nAckQEntries(void) { return aqHead - aqTail; }
static inline int ackQisFull(void} { return NACKQENTRIES == nAckQEntries() }
*/

#endif
