#!/usr/bin/perl
use strict;

my $rpm = "/bin/rpm";
if(! -x $rpm) {
    print "You don't seem to have RPM installed on this system.\n";
    exit 1;
}

my $kernelver = `uname -r`; chomp $kernelver;
$kernelver =~ s/smp//;
$kernelver =~ s/BOOT//;
my $rpmfile   = "kernel-source-$kernelver";
my $okfile    = shift;
return 0 if -f $okfile;
if(`/bin/rpm -q $rpmfile` =~ /is not installed/) {
    print <<EOT;


I've got some bad news for you.  You need to have the kernel headers RPM 
installed before you can build the DOR driver.  The file to install is
$rpmfile.rpm.  


EOT
    ;
    exit 1;
} else {
    print "Kernel headers package $rpmfile found...\n";
    exit system "touch $okfile";
}
